pipeline {

  environment {
    registry = "rapiddockerhub/bma-line"
    registryCredential = 'docker-rapid-tech'
    imagename = "bma-line-frontend"
    dockerImage = ""
  }

  agent any     //{ label 'kubepod' }

  stages {

    stage('Checkout Source') {
      steps {
        git credentialsId: 'git-rapid-tech',
            branch: 'main',
            url: 'https://gitlab.com/jame.rapidtech/bmaline.git'
      }
    }
    
    stage('Build image') {
      steps{
        script {
          dockerImage = docker.build registry + ":$imagename.2023.03.13.$BUILD_NUMBER"
        }
      }
    }
    stage('Push Image') {
      steps{
        script {
          docker.withRegistry( '', registryCredential  ) {
            dockerImage.push()
          }
        }
      }
    }
    stage('Deploy') {
      steps{
        script {
          docker.withRegistry( '', registryCredential  ) {
            sh "docker rm -f $imagename"
            sh "docker run -p 30003:80 --name $imagename -d $registry:$imagename.2023.03.13.$BUILD_NUMBER"
          }
        }
      }
    }

  }
}
